#!/usr/bin/perl -w

use CGI;
use File::Basename;
use File::Path;
use Encode;

$upload_dir = "c:/uploads";
$createsubfolders = "true";
$filename_encoding = "ISO-8859-1";
$request_encoding = "ISO-8859-1";

$message = "";
$query = new CGI;

print $query->header();

unless (-d $upload_dir)
{
   mkpath($upload_dir,0,0755) or die $!;
}

if ($query->param("todo") eq "upload")
{
  # account parameter support.
  $account = $query->param("account");
  if (length($account)>0)
  {
    if (substr($account,0,1) ne "/")
    {
       $account = "/".$account;
    }
  }
  $target_folder = $upload_dir.$account;
  
  # relalivefilename support for folders and subfolders creation.
  my $relative = $query->param("relativefilename");
  $relative =~ s/\\/\//g;
  $relative = encode($filename_encoding, decode($request_encoding,$relative));
  if (($createsubfolders eq "true") && ($relative ne ""))
  {
     my $file_name = $query->param("uploadfile");
     $file_name =~ s/.*[\/\\](.*)/$1/;
     $file_name = encode($filename_encoding, decode($request_encoding,$file_name));
     $inda = length($relative);
     $indb = length($file_name);
     if (($indb > 0) && ($inda > $indb))
     {
        $subfolder = substr($relative,0,($inda-$indb)-1);
        $target_folder = $upload_dir.$account."/".$subfolder;
        mkpath($target_folder,0);
    }
  }  
  
  # save file uploaded
  my $filename = $query->param("uploadfile");
  $filename =~ s/.*[\/\\](.*)/$1/;
  $filename = encode($filename_encoding, decode($request_encoding,$filename));
  my $upload_filehandle = $query->upload("uploadfile");
  if(defined($upload_filehandle))
  {
     open UPLOADFILE, ">$target_folder/$filename" or die $!;
     binmode UPLOADFILE;
     while ( <$upload_filehandle> )
     {
         print UPLOADFILE;
     }
     close UPLOADFILE;
     $message = $filename." uploaded successfully.";
  }
}

print "<html>";
print "<head>";
print "<title>Upload file: PERL/CGI Script sample</title>";
print "</head>";
print "<body>";
print "<center>";
print "   <br>";
print $message;
print "  <form action=\"process.cgi\" method=\"post\" ENCTYPE=\"multipart/form-data\" name=\"upload\" id=\"upload\">";
print "    Select file to upload :";
print "    <input type=\"hidden\" name=\"todo\" value=\"upload\">";
print "    <input type=\"file\" name=\"uploadfile\">";
print "    <input type=\"submit\" name=\"upload\" value=\"Upload\">";
print "  <p>&nbsp;</p>";
print "  <p>&nbsp;</p>";
print "  <p align=\"center\">&nbsp;</p>";
print "  <p align=\"center\">&nbsp;</p>";
print "  <p align=\"center\"><font size=\"-1\" face=\"Courier New, Courier, mono\"><a href=\"http://www.jfileupload.com\" target=\"_blank\">JFileUpload</a></font></p>";
print "   </form>";
print "</center>";
print "</body>";
print "</html>";
